package blackbox

import (
	"strconv"
	"time"

	"bytes"
	"encoding/json"
	"fmt"
	"github.com/axgle/mahonia"
	"io/ioutil"
	"net/http"
	"strings"
	"zks.com/gotcp"
	"zks.com/newbbfrontsocketv2/business/versionmanage"
	"zks.com/socketutils"
	utils "zks.com/zUtils"
	coldcloud "zks.com/zcoldcloud"
)

type GaoDeGpsChange struct {
	Status    string `json:"status"`
	Info      string `json:"info"`
	Locations string `json:"locations"`
}

func GetChannelValue(c *gotcp.Conn, value, command []byte, msgid, msggatewayid string, msgliusid int64) (dataarray []blackboxddata) {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered in f", r)
		}
	}()
	switch msgid {
	case "2004":
		Conns2004.Lock()
		if v, ok := Conns2004.m[msggatewayid]; ok {
			socketutils.InformationalWithFormat("授时:", msggatewayid, "数据:", v)
			if time.Now().Unix()-v.Time < 300 && v.Count+1 > 5 {
				socketutils.InformationalWithFormat("授时主动断开:", msggatewayid)
				c.Close()
				delete(Conns2004.m, msggatewayid)
				Conns2004.Unlock()
				return nil
			}
			if time.Now().Unix()-v.Time > 60*60 {
				Conns2004.m[msggatewayid] = Status2004{time.Now().Unix(), 1}
			} else {
				Conns2004.m[msggatewayid] = Status2004{v.Time, v.Count + 1}
			}
		} else {
			Conns2004.m[msggatewayid] = Status2004{time.Now().Unix(), 1}
		}
		Conns2004.Unlock()
		var uyear, umonth, uday, uhour, uminute, usecond uint64
		t := time.Now().Format("20060102150405")
		uyear, _ = strconv.ParseUint(t[2:4], 16, 0)
		umonth, _ = strconv.ParseUint(t[4:6], 16, 0)
		uday, _ = strconv.ParseUint(t[6:8], 16, 0)
		uhour, _ = strconv.ParseUint(t[8:10], 16, 0)
		uminute, _ = strconv.ParseUint(t[10:12], 16, 0)
		usecond, _ = strconv.ParseUint(t[12:], 16, 0)
		sendms := []byte{0xA0, 0x04, 0x00, 0x06, command[5], command[6], command[7], command[8], command[9], command[10], command[11], command[12], byte(uyear), byte(umonth), byte(uday), byte(uhour), byte(uminute), byte(usecond)}
		sendms = append(sendms, yihuo(sendms))
		send := []byte{0x7E}
		for _, v := range sendms {
			if v == 0x7E {
				send = append(send, 0x7D, 0x02)
			} else if v == 0x7D {
				send = append(send, 0x7D, 0x01)
			} else {
				send = append(send, v)
			}
		}
		send = append(send, 0x7E)
		//err_send := c.WritePacket(NewPacket(3, send))
		n, err_send := c.WritePacketN(NewPacket(3, send))
		socketutils.InformationalWithFormat("守时:", n, "错误信息:", err_send)
	case "2010", "2011":
		temp := value
		if len(temp) < 19 {
			fmt.Println("2010类型数据长度下小于19", len(temp))
			return
		}
		var gdzdcd int64
		switch int(temp[0]) {
		case 3:
			sensors := make(map[string]string)
			temp = temp[10:]
			for {
				sensorid := fmt.Sprintf("%X", temp[1:5])
				fmt.Println("sensorid ", sensorid) //sensorid
				if sensorid != msggatewayid {
					sensors[sensorid] = sensorid
				}
				gdzdcd = 14
				sjnewcom := temp[gdzdcd+1:]
				tempnew := S6ForWriter(sjnewcom)
				temp = tempnew
				fmt.Println("剩余长度", len(temp))
				if len(temp) == 0 {

					break
				}
			}
			for sensor, _ := range sensors {
				DParamSensorSet(c, sensor, msggatewayid)
			}
		}
		if msgid == "2011" {
			fmt.Println("-------> [反馈分支][2011]")
			// 发送反馈信息
			rawMsg := []byte{0xA0, 0x01, 0x00, 0x05, command[5], command[6], command[7], command[8], command[9], command[10], command[11], command[12]}
			rawMsg = append(rawMsg, Valuebyte2(int(msgliusid))...)
			rawMsg = append(rawMsg, 0x20, 0x11, 0x00)
			rawMsg = append(rawMsg, yihuo(rawMsg))
			message := []byte{0x7E}
			for _, v := range rawMsg {
				if v == 0x7E {
					message = append(message, 0x7D, 0x02)
				} else if v == 0x7D {
					message = append(message, 0x7D, 0x01)
				} else {
					message = append(message, v)
				}
			}
			message = append(message, 0x7E)
			fmt.Println("_ _ _ _ _ _ _ _ _ _ _ _ _ _ [2011][Response] _ _ _ _ _ _ _ _ _ _ _ _ _ _")
			fmt.Println("[Msg]", fmt.Sprintf("%X", message))
			go WritePacketAndLog(c, message, time.Now().Unix())
		}
	case "2024":
		if len(value) < 3 {
			return
		}
		//当前软件版本
		banben := fmt.Sprintf("%X", value[0:2])
		fmt.Println("当前软件版本 ", banben)
		//项目名长度
		namelengthx := fmt.Sprintf("%X", value[2])
		namelength, _ := strconv.ParseInt(namelengthx, 16, 64)
		fmt.Println("项目名长度 ", namelength)
		if len(value) < (3 + int(namelength)) {
			return
		}
		projectname := byteToAscii(value[3 : 3+namelength])
		fmt.Println("项目名 ", projectname)
		var version versionmanage.VersionManage
		strUrl := Config.Send.Waterdrop.Service + "/remoteupgrade/newestversion?projecttag=1&projectname=" + projectname + "&versionnum=" + banben + "&mainserial=" + msggatewayid
		json.Unmarshal(Apiget(strUrl), &version)
		strUrl = Config.Send.Waterdrop.Service + "/remoteupgrade/upgradehistory/device?projecttag=1&projectname=" + projectname + "&currversion=" + banben + "&mainserial=" + msggatewayid + "&upversion=" + utils.ToStr(version.VersionNum)
		json.Unmarshal(Apiget(strUrl), nil)
		if version.Id == 0 {
			fmt.Println("无升级数据包")
			return
		}
		var newbanben = version.VersionName
		//var banbenname ="S6_1139"
		bytestr, err := ioutil.ReadFile("/home/wwwroot/zksiotservice/waterdrop/web" + version.FilePath)
		if err != nil {
			fmt.Println("升级文件读取异常", err)
		}
		one, _ := strconv.ParseUint(newbanben[1:3], 16, 0)
		two, _ := strconv.ParseUint(newbanben[3:5], 16, 0)
		message := []byte{byte(one), byte(two)}
		message = append(message, Valuebyte4(len(bytestr))...)
		sendms := []byte{0xA0, 0x08, 0x00, byte(len(message)), command[5], command[6], command[7], command[8], command[9], command[10], command[11], command[12], byte(one), byte(two)}
		sendms = append(sendms, Valuebyte4(len(bytestr))...)
		sendms = append(sendms, yihuo(sendms))
		send := []byte{0x7E}
		for _, v := range sendms {
			if v == 0x7E {
				send = append(send, 0x7D, 0x02)
			} else if v == 0x7D {
				send = append(send, 0x7D, 0x01)
			} else {
				send = append(send, v)
			}
		}
		send = append(send, 0x7E)
		c.WritePacket(NewPacket(3, send))
		var emtity coldcloud.DUpgrade
		coldcloud.UpdateControlDUpgrade("CTL"+msggatewayid, emtity)
	case "2025":
		if len(value) < 7 {
			return
		}
		//当前软件版本
		banben := fmt.Sprintf("%X", value[0:2])
		fmt.Println("升级软件版本 ", banben)
		//分包序号
		fenbaoxuliehaox := fmt.Sprintf("%X", value[2:4])
		fenbaoxuliehaod, _ := strconv.ParseInt(fenbaoxuliehaox, 16, 64)
		fmt.Println("分包序号 ", fenbaoxuliehaod)
		//分包长度
		fenbaoxchangdux := fmt.Sprintf("%X", value[4:6])
		fenbaoxchangdud, _ := strconv.ParseInt(fenbaoxchangdux, 16, 64)
		fmt.Println("分包长度 ", fenbaoxchangdud)
		//项目名长度
		namelengthx := fmt.Sprintf("%X", value[6])
		namelength, _ := strconv.ParseInt(namelengthx, 16, 64)
		fmt.Println("项目名长度 ", namelength)
		if len(value) < (7 + int(namelength)) {
			return
		}
		//项目名
		projectname := byteToAscii(value[7 : 7+namelength])
		fmt.Println("项目名 ", projectname)
		var version versionmanage.VersionManage
		strUrl := Config.Send.Waterdrop.Service + "/remoteupgrade/versiondetail?projecttag=1&projectname=" + projectname + "&versionnum=" + banben
		json.Unmarshal(Apiget(strUrl), &version)
		if version.Id == 0 {
			fmt.Println("无升级数据包")
			return
		}
		bytestr, err := ioutil.ReadFile("/home/wwwroot/zksiotservice/waterdrop/web" + version.FilePath)
		if err != nil {
			fmt.Println("升级文件读取异常", err)
		}
		databyte := []byte{}
		if (int(fenbaoxuliehaod)+1)*int(fenbaoxchangdud) > len(bytestr) {
			databyte = bytestr[fenbaoxuliehaod*fenbaoxchangdud:]
		} else {
			databyte = bytestr[fenbaoxuliehaod*fenbaoxchangdud : (int(fenbaoxuliehaod)+1)*int(fenbaoxchangdud)]
		}
		fmt.Println(databyte)
		message := []byte{}
		message = append(message, value[0:4]...)
		message = append(message, Valuebyte2(len(databyte))...)
		message = append(message, databyte...)
		sendms := []byte{0xA0, 0x09}
		sendms = append(sendms, Valuebyte2(len(message))...)
		sendms = append(sendms, []byte{command[5], command[6], command[7], command[8], command[9], command[10], command[11], command[12]}...)
		sendms = append(sendms, message...)
		sendms = append(sendms, yihuo(sendms))
		send := []byte{0x7E}
		for _, v := range sendms {
			if v == 0x7E {
				send = append(send, 0x7D, 0x02)
			} else if v == 0x7D {
				send = append(send, 0x7D, 0x01)
			} else {
				send = append(send, v)
			}
		}
		send = append(send, 0x7E)
		c.WritePacket(NewPacket(3, send))
	}
	return
}

//S6多探头循环写入
func S6ForWriter(sjnewcom []byte) (temp []byte) {
	for {
		//数据项列表长度
		sjlength := len(sjnewcom)
		if sjlength < 2 {
			sjnewcom = []byte{}
			break
		}
		//获取端口编号
		portnumx := fmt.Sprintf("%X", sjnewcom[0])
		portnumint64, _ := strconv.ParseInt(portnumx, 16, 32)
		portnumint := int(portnumint64)
		if portnumint == 255 {
			sjnewcom = sjnewcom[1:]
			break
		}
		//获取数据类型
		datatypestr := fmt.Sprintf("%X", sjnewcom[1])
		datatype, _ := strconv.ParseInt(datatypestr, 16, 32)
		if datatype == 1 {
			if len(sjnewcom[2:]) < 4 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[6:]
		} else if datatype == 2 {
			if len(sjnewcom[2:]) < 2 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[4:]
		} else if datatype == 3 {
			if len(sjnewcom[2:]) < 4 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[6:]
		} else if datatype == 4 {
			if len(sjnewcom[2:]) < 3 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[5:]
		} else if datatype == 5 { //压力传感器
			if len(sjnewcom[2:]) < 4 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[6:]
		} else if datatype == 10 {
			if len(sjnewcom[2:]) < 4 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[6:]
		} else if datatype == 11 {
			if len(sjnewcom[2:]) < 16 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[18:]
		} else if datatype == 12 {
			if len(sjnewcom[2:]) < 1 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[3:]
		} else if datatype == 13 {
			if len(sjnewcom[2:]) < 1 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[2:]
		} else if datatype == 254 {

			if len(sjnewcom[2:]) < 6 {
				sjnewcom = sjnewcom[2:]
				break
			}
			sjnewcom = sjnewcom[8:]
		} else {
			fmt.Println("不定项的除了STH20和NTC其他类型", datatype)
			sjnewcom = []byte{}
			break
		}
	}
	return sjnewcom
}

//设置参数
func DParamSensorSet(c *gotcp.Conn, sensor, msggatewayid string) {
	paramset, _ := coldcloud.GetReverseControlDParam("CTL" + sensor)
	if paramset.Id != 0 && len(sensor) >= 8 {
		head := []byte{0xA0, 0x02, 0x00}
		sendms := []byte{}
		sensormac1, _ := strconv.ParseInt(sensor[0:2], 16, 64)
		sensormac2, _ := strconv.ParseInt(sensor[2:4], 16, 64)
		sensormac3, _ := strconv.ParseInt(sensor[4:6], 16, 64)
		sensormac4, _ := strconv.ParseInt(sensor[6:8], 16, 64)
		sendms = append(sendms, 0x00, byte(sensormac1), byte(sensormac2), byte(sensormac3), byte(sensormac4))
		for _, v := range paramset.SetValue {
			if time.Now().Unix()-v.CreateOn.Unix() > (60 * 120) {
				break
			}
			switch v.Dtype {
			case 1:
				zksint, _ := utils.StrTo(v.Value).Int()
				sendms = append(sendms, byte(v.Dtype))
				sendms = append(sendms, Valuebyte4(zksint)...)
			case 2:
				zksint, _ := utils.StrTo(v.Value).Int()
				sendms = append(sendms, byte(v.Dtype))
				fmt.Println(fmt.Sprintf("% X", sendms))
				sendms = append(sendms, Valuebyte4(zksint)...)
			case 3:
				zksfloat, _ := utils.StrTo(v.Value).Float32()
				zksint := int(zksfloat * 100)
				sendms = append(sendms, byte(v.Dtype))
				sendms = append(sendms, byte(v.Port))
				if zksint >= 0 {
					sendms = append(sendms, Valuebyte2(zksint)...)
				} else {
					sendms = append(sendms, Bumatobyte2(zksint)...)
				}
			case 4:
				zksfloat, _ := utils.StrTo(v.Value).Float32()
				zksint := int(zksfloat * 100)
				sendms = append(sendms, byte(v.Dtype))
				sendms = append(sendms, byte(v.Port))
				if zksint >= 0 {
					sendms = append(sendms, Valuebyte2(zksint)...)
				} else {
					sendms = append(sendms, Bumatobyte2(zksint)...)
				}
			case 11:
				name := []byte(CodertoGBK(utils.Substr(v.Value, 0, 10)))
				sendms = append(sendms, byte(v.Dtype))
				sendms = append(sendms, byte(len(name)))
				sendms = append(sendms, name...)
			case 27:
				zksfloat, _ := utils.StrTo(v.Value).Float32()
				zksint := int(zksfloat * 100)
				sendms = append(sendms, byte(v.Dtype))
				sendms = append(sendms, byte(v.Port))
				if zksint >= 0 {
					sendms = append(sendms, Valuebyte2(zksint)...)
				} else {
					sendms = append(sendms, Bumatobyte2(zksint)...)
				}
			case 28: //湿度校正
				zksfloat, _ := utils.StrTo(v.Value).Float32()
				zksint := int(zksfloat * 100)
				sendms = append(sendms, byte(v.Dtype))
				sendms = append(sendms, byte(v.Port))
				if zksint >= 0 {
					sendms = append(sendms, Valuebyte2(zksint)...)
				} else {
					sendms = append(sendms, Bumatobyte2(zksint)...)
				}
			}
		}
		if len(sendms) == 0 {
			//Apipost(Config.Send.Waterdrop.Service+"/dparamset/setv2?mainserial="+sensor+"&num="+utils.ToStr(paramset.ControlNum)+"&state=2", "POST", nil)
			var dparamset coldcloud.DParamSet
			coldcloud.UpdateCTLDParamSet("CTL"+sensor, dparamset)
		} else {
			mac1, _ := strconv.ParseInt(msggatewayid[0:2], 16, 64)
			mac2, _ := strconv.ParseInt(msggatewayid[2:4], 16, 64)
			mac3, _ := strconv.ParseInt(msggatewayid[4:6], 16, 64)
			mac4, _ := strconv.ParseInt(msggatewayid[6:8], 16, 64)
			head = append(head, byte(len(sendms)), byte(mac1), byte(mac2), byte(mac3), byte(mac4), 0x00, 0x00)
			head = append(head, Valuebyte2(paramset.ControlNum)...)
			sendms = append(head, sendms...)
			sendms = append(sendms, yihuo(sendms))
			send := []byte{0x7E}
			for _, v := range sendms {
				if v == 0x7E {
					send = append(send, 0x7D, 0x02)
				} else if v == 0x7D {
					send = append(send, 0x7D, 0x01)
				} else {
					send = append(send, v)
				}
			}
			send = append(send, 0x7E)
			fmt.Println("反向控制命令", fmt.Sprintf("% X", send))
			c.WritePacket(NewPacket(3, send))
		}
	}
}
func byteToAscii(signalList []byte) (str string) {
	for i := 0; i < len(signalList); i++ {
		if signalList[i] != 0x00 {
			str += string(signalList[i])
		}
	}
	return str
}
func yihuo(signalList []byte) byte {
	var xor byte
	xor = signalList[0]
	for i := 1; i < len(signalList); i++ {
		xor ^= signalList[i]
	}
	return xor
}

//把16进制转换为二进制字符串
func ByteToBinaryString(data byte) (str string) {
	var a byte
	for i := 0; i < 8; i++ {
		a = data
		data <<= 1
		data >>= 1
		switch a {
		case data:
			str += "0"
		default:
			str += "1"
		}
		data <<= 1
	}
	return str
}

//把一个字节的二进制字符串转换为十进制数字
func btox(b string) string {
	base, _ := strconv.ParseInt(b, 2, 12)

	return strconv.FormatInt(base, 10)
}

//把一个字节的二进制字符串转换为十六进制数字
func btox16(b string) string {
	base, _ := strconv.ParseInt(b, 2, 12)

	return strconv.FormatInt(base, 16)
}
func Substr(str string, start int, length int) string {
	rs := []rune(str)
	rl := len(rs)
	end := 0

	if start < 0 {
		start = rl - 1 + start
	}
	end = start + length

	if start > end {
		start, end = end, start
	}

	if start < 0 {
		start = 0
	}
	if start > rl {
		start = rl
	}
	if end < 0 {
		end = 0
	}
	if end > rl {
		end = rl
	}

	return string(rs[start:end])
}

//数值转为2个字节
func Valuebyte2(v int) []byte {
	value := make([]byte, 2)
	value[0] = byte(v >> 8 & 0xff)
	value[1] = byte(v & 0xff)
	return value
}

//数值转为4个字节
func Valuebyte4(v int) []byte {
	value := make([]byte, 4)
	value[0] = byte(v >> 24 & 0xff)
	value[1] = byte(v >> 16 & 0xff)
	value[2] = byte(v >> 8 & 0xff)
	value[3] = byte(v & 0xff)
	return value
}

//2个字节的补码
func Bumatobyte2(v int) []byte {
	value := make([]byte, 2)
	if v < 0 {
		v = 65535 + 1 + v
	}
	value[0] = byte(v >> 8 & 0xff)
	value[1] = byte(v & 0xff)
	return value
}

//4个字节的补码
func Bumabyte4(v int64) []byte {
	value := make([]byte, 4)
	if v < 0 {
		v = 4294967295 + 1 + v
	}
	value[0] = byte(v >> 24 & 0xff)
	value[1] = byte(v >> 16 & 0xff)
	value[2] = byte(v >> 8 & 0xff)
	value[3] = byte(v & 0xff)
	return value
}
func Apipost(strUrl, method string, postDict interface{}) (body []byte) {
	strUrl = strings.Replace(strUrl, " ", "%20", -1)
	httpClient := &http.Client{
		//Transport:nil,
		//CheckRedirect: nil,
	}

	var httpReq *http.Request

	b, _ := json.Marshal(postDict)
	postBytesReader := bytes.NewReader(b)
	httpReq, _ = http.NewRequest(method, strUrl, postBytesReader)
	httpReq.Header.Add("Content-Type", "application/json")
	response, _ := httpClient.Do(httpReq)
	body, _ = ioutil.ReadAll(response.Body)
	return
}
func Apiget(str string) (body []byte) {
	str = strings.Replace(str, " ", "%20", -1)
	response, _ := http.Get(str)
	if response != nil {
		defer response.Body.Close()
		body, _ = ioutil.ReadAll(response.Body)
	}
	//json.Unmarshal(body, &devices)
	return
}
func CodertoGBK(str string) string {
	dec := mahonia.NewDecoder("UTF-8")
	enc := mahonia.NewEncoder("GBK")
	return enc.ConvertString(dec.ConvertString(str))
}

//发送给设备并且打印日志
func WritePacketAndLog(c *gotcp.Conn, message []byte, sendtime int64) {
	responseError := c.WritePacket(NewPacket(3, message))
	fmt.Println("反向控制[UsedTime]", time.Now().Unix()-sendtime, "[Msg]", fmt.Sprintf("%X", message))
	if responseError != nil {
		fmt.Println("[ResponseError]", responseError)
	}
}
