package blackbox

import (
	"io/ioutil"
	"os"

	"github.com/naoina/toml"
)

type AppConfig struct {
	Send struct {
		Redis struct {
			Addr    string
			Poolnum int
			Pwd     string
		}
		Nsq struct {
			Nsqdtcpaddr string
			Topic       string
		}
		Nsqrequest struct {
			Nsqdtcpaddr string
			Topic       string
		}
		Waterdrop struct {
			Service string
		}
	}
	Service struct {
		Ipandport string
	}
}

var Config AppConfig

func ReadAppConfig(path string) (config AppConfig) {
	f, err := os.Open(path)
	if err != nil {
		panic(err)
	}
	defer f.Close()
	buf, err := ioutil.ReadAll(f)
	if err != nil {
		panic(err)
	}
	if err := toml.Unmarshal(buf, &config); err != nil {
		panic(err)
	}
	return
}
